* =======================================================================
* EQUATES_ASM.
*
* This file is included by QLTdis_asm and is used to define various
* constants that are used within the source code. This is instead of
* a whole lot of 'magic' numbers. 
*
* For example, using GREEN instead of 4 is a bit more meaningful.
* =======================================================================

* -----------------------------------------------------------------------
* These are offsets from the start of the job's dataspace where working
* variable are stored. The dataspace is held at (A4) in the job's code.
* -----------------------------------------------------------------------
con_id      equ     0                   ; Id for title channel
con_id2     equ     4                   ; Id for main output
prt_id      equ     8                   ; Id for printer channel
pc_addr     equ    12                   ; Start address of next instruction
pc_end      equ    16                   ; Stop after this address

* -----------------------------------------------------------------------
* These are simply user friendly names instead of numbers for various
* bits and bobs, colours etc.
* -----------------------------------------------------------------------
black       equ     0                   ; Colour code for mode 4 black
red         equ     2                   ; Red
green       equ     4                   ; Green
white       equ     7                   ; White
linefeed    equ    10                   ; Linefeed character

* -----------------------------------------------------------------------
* Constants for use with job control commands. (It doesn't matter if I
* have two names with the same value ! )
* -----------------------------------------------------------------------
infinite    equ     -1                  ; Infinite timeout
me          equ     -1                  ; Id for 'this' job
