* =======================================================================
* TERM_ASM.
*
* This file is included by QLTdis_asm and is used to define various
* termination routines and any parameters used by them. The jobs main
* termination and each loop's termination are defined in this file.
* =======================================================================



* =======================================================================
* Terminate main loop :
* =======================================================================
* 1. Close 'printer' file
* 2. Tidy addresses etc in storage ready for next time (if required)
* =======================================================================
loop_term   moveq    #0,d0                ; No errors
            rts


* =======================================================================
* All_done :
* =======================================================================
* 1. Remove the current job - forcibly
* 2. Loop around just in case something went wrong and the job was not
*    properly removed.
* =======================================================================
all_done    moveq   #mt_frjob,d0        ; Force Remove a job
            moveq   #me,d1              ; The current job
            move.l  d0,d3               ; Any error code to send to Superbasic
            trap    #1                  ; Kill this job, its channels and its memory

            bra.s   all_done            ; Should never get here - sanity check !
