* QL WORLD March 88 - USE  procedure
*        by Simon N Goodwin
*
*
*  ------------------------------
* |        Version 2.1           |
* |                              |
* |   Altered  - 17th July 1998  |
* | by George Gwilt for use with |
* |            SMSQ/E            |
*  ------------------------------
*
BP.INIT   EQU       $110
CA.GTINT  EQU       $112
BV.CHBAS  EQU       $30
BV.CHP    EQU       $34
MT.INF    EQU       0
SV.JBBAS  EQU       $68
JB.TAG    EQU       $10
N_Jobs    EQU       4
*
START     LEA       DEFINE,A1
          MOVE.W    BP.INIT,A2
          JMP       (A2)
*
DEFINE    DC.W      1  1 procedure
          DC.W      CH_USE-*
          DC.B      3,'USE'
          DC.W      0,0,0  No functions
*
CH_USE    CMP.L     A3,A5               Parameters? . .
          BNE.S     READ_CH             . . Yes
RESET_CHL MOVE.L    BV.CHBAS(A6),A1
          LEA       40(A1),A1
          LEA       JB_SP,A2
          MOVEQ     #MT.INF,D0          D1 = this job's ID
          TRAP      #1
          TRAP      #0
;
; Now in supervisor mode
;
          MOVE.W    SR,D7
          ORI.W     #$700,SR            stop interrupts
          MOVEQ     #N_Jobs-1,D2
L1        CMP.L     (A2)+,D1            see if this job in list . .
          DBEQ      D2,L1
          BNE       NO_ERROR1           . . not there so no action
          MOVE.L    4*N_JOBS-4(A2),(A1,A6.L)      reset #ID
          ST        -2(A2)              clear this item
          ANDI.W    #$DFFF,D7
          MOVE      D7,SR
;
; Now back to user mode
;
          MOVEQ     #4,D3
CLEAR_CHL ADDQ.L    #4,A1
          CLR.L     (A1,A6.L)
          DBF       D3,CLEAR_CHL
          MOVEQ     #80,D3
          MOVE.L    D3,4(A1,A6.L)
          BRA       NO_ERROR
*
* Read channel no -> D3
*
READ_CH   LEA       8(A3),A0
          CMP.L     A0,A5
          BNE       BAD_PARAM
          MOVE.W    CA.GTINT,A2
          JSR       (A2)
          BNE       BAD_EXIT
          MOVE.W    (A1,A6.L),D3
          CMPI.W    #1,D3               "USE 1" means reset
          BEQ       RESET_CHL
*
* Track down data in channel table
*
          MOVE.L    BV.CHBAS(A6),A1
          MOVEQ     #40,D4
*
* Check channel no in D3 and convert to offset
*
CHAN_SEL  MULU.W    D4,D3
          ADD.L     A1,D3
          CMP.L     BV.CHP(A6),D3
          BGE.S     WHAT_CHAN ---->
          MOVE.L    (A6,D3.L),D5
          BMI.S     WHAT_CHAN ---->
          ADD.L     A1,D4
          MOVEQ     #MT.INF,D0
          TRAP      #1                  A0 -> SYS VARS, D1 = JOB ID
          LEA       JB_SP,A2
          MOVEQ     #N_Jobs-1,D2        count
          TRAP      #0
;
; supervisor mode
;
          MOVE.W    SR,D7
          ORI.W     #$700,SR            stop interrupts
L2        CMP.L     (A2)+,D1            is job in list? . .
          DBEQ      D2,L2
          BEQ.S     CPY_CH1             . . yes, #1 already saved
          MOVEQ     #N_Jobs-1,D2        count again
L3        TST.B     -2(A2)              free space? . .
          SUBQ.L    #4,A2
          DBMI      D2,L3
          BPL.S     L6                  . . not yet
          ADDQ.L    #4,A2
          BRA.S     L4                  space found
;
; We must see if jobs in the list are current
;
L6        MOVEQ     #N_Jobs-1,D2
          MOVE.L    SV.JBBAS(A0),A0     pointer to job list
L5        MOVE.L    (A2)+,D6            Job ID in list
          MOVE.W    D6,D0
          LSL.W     #2,D0
          MOVE.L    (A0,D0.W),D0        pointer to job
          BMI.S     L4                  Job dead - so space found
          MOVEA.L   D0,A5
          MOVE.W    JB.TAG(A5),D0       current job tag
          SWAP      D6
          CMP.W     D6,D0
          DBNE      D2,L5               Are all jobs current? . .
          BEQ.S     NO_ROOM             . . yes - so no room
L4        MOVE.L    D1,-4(A2)           set job ID
          MOVE.L    (A6,D4.L),4*N_JOBS-4(A2)      set #ID
*
* Copy from offset D3 -> offset D4
*
CPY_CH1   MOVEQ     #9,D2
COPY_CH   MOVE.L    (A6,D3.L),(A6,D4.L)
          ADDQ.L    #4,D3
          ADDQ.L    #4,D4
          DBF       D2,COPY_CH
*
NO_ERROR1 ANDI.W    #$DFFF,D7
          MOVE      D7,SR
NO_ERROR  MOVEQ     #0,D0
          RTS
WHAT_CHAN MOVEQ     #-6,D0
          RTS
BAD_PARAM MOVEQ     #-15,D0
BAD_EXIT  RTS
;
NO_ROOM   ANDI.W    #$DFFF,D7
          MOVE      D7,SR
;
; -> user mode
;
          MOVEQ     #-5,D0
          RTS
;
JB_SP     DC.L      -1,-1,-1,-1,0,0,0,0
;
; JB_SP is a table of N_Jobs job IDs where USE is in operation.
; An entry with negative bottom word indicates a free space.
; The second set of long words is for the corresponding #IDs for
; the various channel 1s.
